' CrystalCF.bas for FilmStar CRYSTAL
' Copyright 1995-2007 FTG Software Associates
'
' Illustrates use of DESIGN Layer Error correction in CRYSTAL
'
Option Explicit
DefInt i-N
DefSng A-H, O-Z
Option Base 1

Sub Main
    Dim i, qKA, qNM, qNMTotH, qNMSubTotH, Rate, t1, t2, v
    WsRecalc     ' recalculate worksheet

    t1 = ThickLimit  ' default %
    t2 = TimeLimit   ' default minutes

    For i = 1 To NumLayers
        qNM = 100 * FilmThick(i)    ' FilmThick(i) in kA

        Select Case UCase$(WsGetText(i, 2))
        Case "SIO2"
            v = qNM * CF_L(qNM)
        Case "TIO2"
            qNMTotH = qNMSubTotH + .5*qNM
            qNMSubTotH = qNMSubTotH + qNM
            v = qNM * CF_H(qNMTotH)
        End Select

        ' Final Thick column 5
        WsSetNum i, 5, .01 * v

        ' Thick Limit column 6
        WsSetNum i, 6, .0001 * v * t1     ' t1 in %

        Rate = WsGetNum(i, 4)
        ' Time Limit column 7
        WsSetNum i, 7, t2 + 10 * v / (60 * Rate)
   Next i
   WsRedraw 1
End Sub

Function CF_L(ByVal qLay As Single) As Single ' qLay is Layer Thickness (nm)
    'SiO2
    CF_L = 1.00170 - 1.3390E-4 * qLay
End Function

Function CF_H(ByVal qTot As Single) As Single ' qTot is Total Thickness (nm)
    'TiO2
    CF_H = 0.99852 - 4.6743E-6 * qTot + 6.5059E-8 * qTot^2
End Function
