' FilmSolve0.bas for FilmStar DESIGN
' Copyright 2007 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program calculates the confidence level for reverse synthesis
' according to the following method:
'
' 1. Generate a design with random errors
' 2. Calculate the spectrum and convert to targets at 0
' 3. Restore the original design and solve for layers by optimization
' 4. Pass = all layers within Verification Level = TestPC/100 (default 0.5%)
'
' To run this program as a macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   Film Solve 0
'   Command       basrun c:\winfilm\basic32\FilmSolve0.bas;
'

Option Explicit
DefInt i-N
DefSng A-H, O-Z
Option Base 1

Public Const Iter = 10      ' change as required

Sub Main
    Dim i, k, IterNG, nLayers, Design0$, qDesign(), qDesc$(), qSolve(), qType$()
    Dim TestPC, bOK As Boolean

    TestPC = Val(InputBox("Enter Verification Level in %", "Reverse Synthesis Test", "0.5"))
    If TestPC > 0 Then
        MainEvents = True   ' enables Abort menu command
        Design0 = Design
        Angle = 0
        For i = 1 To Iter
            AxesDraw
            StatusLabel CStr(i) & "/" & CStr(Iter)
            Design = Design0    ' original design
            CalcRand 0, 1       ' randomize layers, retaining randomized design
            GetLayers nLayers, qDesign(), qType$(), qDesc()
            FileSave "temp.dx"  ' save to replot later
            SpecTargets  True, "R", 1, 0, "R"
            Design = Design0    ' original design
            Optimize    ' solve
            GetLayers nLayers, qSolve(), qType$(), qDesc()
            bOK = True
            For k = 1 To nLayers
                If Abs(qSolve(k) - qDesign(k))/qDesign(k) > TestPC/100 Then
                    IterNG = IterNG + 1 ' fails
                    bOK = False
                    Exit For
                End If
            Next k
            If PgmExe = "Demo132" Then
                If bOK Then
                    StatusLabel "Passes"
                Else
                    StatusLabel "Fails"
                End If
                Wait 2
            Else
                AxesDraw
                LineColor "B"
                FileOpen "temp.dx"
                Replot   ' replot original randomized design
                Wait 2
                If bOK Then LineColor "G" Else LineColor "R"
                CalcPlot ' calculate and plot solution at 0
                Wait 3
            End If
        Next i
        Design = Design0
        MsgBox "Confidence Level = " & CStr(100*(Iter- IterNG)/Iter) & "%", vbInformation, "Inverse Synthesis 0"
    End If
    LineColor "R"
End Sub
