' LayErrAdjust.bas for FilmStar DESIGN
' Copyright 2007 FTG Software Associates
'
' This program corrects manufacturing errors
' using Layer Error Analyzer CF functions
' NOTE THAT THIS CHANGES THE OPTIMIZED DESIGN
' TO A NEW DESIGN FOR OPTICAL/PHYSICAL MONITORING

Option Explicit
DefInt i-N
DefSng A-H, O-Z

Sub Main
    Dim qTotH, qSubTotH, qTotL, qSubTotL
    Dim i, iLay, nLay, q(), qT$(), qd$()
    GetLayers nLay, q(), qT$(), qd$()
    For i=1 To nLay
        Select Case qT$(i)
        Case "L"
            ' qTotL = qSubTotL + .5*q(i)
            ' qSubTotL = qSubTotL + q(i)
            ' L error is function of layer thickness q(i) so qTotL not used here
            q(i) = q(i) * CF_L(q(i))
        Case "H"
            qTotH = qSubTotH + .5*q(i)
            qSubTotH = qSubTotH + q(i)
            ' H error is function of total thickness qTotH
            q(i) = q(i) * CF_H(qTotH)
        End Select
    Next i
    SetLayers q(), qT() ' design now includes correction factors
    MsgBox "Warning: Save adjusted design with new name (.dew suggested)!", vbCritical, "Layer Error Adjust"
End Sub

Function CF_L(ByVal qLay As Single) As Single ' qLay is Layer Thickness (QWOT=.25)
    'Adjust L layers
    CF_L = 0.99991 - 4.1809E-2 * qLay
End Function

Function CF_H(ByVal qTot As Single) As Single ' qTot is Total Thickness (QWOT=.25)
    'Adjust H layers (changing tooling factor)
    CF_H = 0.99984 - 6.9209E-4 * qTot + 7.3800E-3 * qTot^2
End Function
